-- BIG BARK ROOT BEER

--item flags
local XIF_POWERITEM = 1 --is power item (affects final odds)
local XIF_COOLDOWNONSTART = 2 --can't be obtained on start cooldown
local XIF_UNIQUE = 4 --only one can exist in anyone's slot
local XIF_LOCKONUSE = 8 --locks the item slot when the item is used, slot must be unlocked manually by setting player.xItemData.xItem_itemSlotLocked to false
local XIF_COOLDOWNINDIRECT = 16 --checks if indirectitemcooldown is 0
local XIF_COLPATCH2PLAYER = 32 --map hud patch colour to player prefcolor
local XIF_ICONFORAMT = 64 --item icon changes depending on the item amount (animation frames become amount frames)

freeslot(
	"sfx_cblsht",
	"sfx_cblbsh",
	"sfx_cblded",
	"sfx_cblemp",
	"sfx_cblrld",
	"SPR_XCBL",
	"SPR_BULL",
	"SPR_LSTB",
	"SPR_CBPF",
	"MT_XSNAPSHOT",
	"S_XSNAPSHOT",
	"S_XSNAPDEADSHOT1",
	"S_XSNAPDEADSHOT2",
	"S_XSNAPDEADSHOT3",
	"S_XSNAPDEADSHOT4",
	"MT_XSNAPLASTSHOT",
	"S_XSNAPLASTSHOT",
	"MT_XSNAPLASTORBITSHOT",
	"S_XSNAPORBITSHOT",
	"MT_XSNAPMISFIRE",
	"S_XSNAPMISFIRE"
)

-----------------------
-- Regular Shot Mobj --
-----------------------
mobjinfo[MT_XSNAPSHOT] = {
	spawnstate = S_XSNAPSHOT,
	seesound = sfx_cblsht,
	deathstate = S_NULL,
	deathsound = sfx_cblded,
	speed = 64*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 24*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY
}
states[S_XSNAPSHOT] = {SPR_BULL, A|FF_FULLBRIGHT|FF_ANIMATE, -1, nil, 1, 2, S_XSNAPSHOT}
states[S_XSNAPDEADSHOT1] = {SPR_BULL, C|FF_FULLBRIGHT, 2, nil, 0, 0, S_XSNAPDEADSHOT2}
states[S_XSNAPDEADSHOT2] = {SPR_BULL, D|FF_FULLBRIGHT, 2, nil, 0, 0, S_XSNAPDEADSHOT3}
states[S_XSNAPDEADSHOT3] = {SPR_BULL, E|FF_FULLBRIGHT, 2, nil, 0, 0, S_XSNAPDEADSHOT4}
states[S_XSNAPDEADSHOT4] = {SPR_BULL, F|FF_FULLBRIGHT, 2, nil, 0, 0, S_NULL}
--------------------
-- Last Shot Mobj --
--------------------
mobjinfo[MT_XSNAPLASTSHOT] = {
	spawnstate = S_XSNAPLASTSHOT,
	seesound = sfx_cblbsh,
	deathstate = S_NULL,
	deathsound = sfx_cblded,
	speed = 64*FRACUNIT,
	radius = 24*FRACUNIT,
	height = 24*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY
}
states[S_XSNAPLASTSHOT] = {SPR_LSTB, A|FF_FULLBRIGHT|FF_ANIMATE, -1, nil, 3, 2, S_XSNAPLASTSHOT}

addHook("MobjThinker", function(mo)
	mo.orbitindex = $ or leveltime % 8
	if mo.orbitindex == 0 then
		P_SpawnGhostMobj(mo)
	end
	
	local ha = mo.angle + ANGLE_90
	local va = mo.orbitindex * ANGLE_45 + ((mo.orbitindex % 2) * ANGLE_180)
	local dist = mo.radius * 3 / 2
	local spawnx = FixedMul(dist, FixedMul(cos(ha), cos(va)))
	local spawny = FixedMul(dist, FixedMul(sin(ha), cos(va)))
	local spawnz = FixedMul(dist * 4 / 5, sin(va)) + (FRACUNIT / 2)
	local bullet = P_SpawnMobj(mo.x+spawnx, mo.y+spawny, mo.z+spawnz, MT_XSNAPLASTORBITSHOT)
	bullet.target = mo
	bullet.id = mo.orbitindex
	bullet.scale = mo.scale * 3 / 2
	bullet.angle = mo.angle
	bullet.color = SKINCOLOR_GOLD
	
	mo.orbitindex = ($ + 1) % 8
end, MT_XSNAPLASTSHOT)
-----------------------
-- Last Shot Orbital --
-----------------------
mobjinfo[MT_XSNAPLASTORBITSHOT] = {
	spawnstate = S_XSNAPORBITSHOT,
	seesound = sfx_cblsht,
	deathstate = S_NULL,
	deathsound = sfx_cblded,
	speed = 64*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 24*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}
states[S_XSNAPORBITSHOT] = {SPR_BULL, A|FF_FULLBRIGHT|FF_ANIMATE, -1, nil, 1, 2, S_XSNAPORBITSHOT}

addHook("MobjThinker", function(mo)
	mo.birthtime = $ or leveltime
	
	local alpha = leveltime - mo.birthtime - 4
	if alpha > 8 then
		P_RemoveMobj(mo)
		return
	elseif alpha > 3 then
		mo.color = SKINCOLOR_MAROON
		mo.frame = G+((leveltime%4)/2)|FF_FULLBRIGHT|alpha<<FF_TRANSSHIFT
	elseif alpha > 0 then
		if mo.target and mo.target.valid then
			local ha = mo.target.angle + ANGLE_90
			local va = mo.target.orbitindex * ANGLE_45 + ((mo.target.orbitindex % 2) * ANGLE_180)
			local dist = mo.target.radius * 3 / 2
			local movex = FixedMul(dist, FixedMul(cos(ha), cos(va)))
			local movey = FixedMul(dist, FixedMul(sin(ha), cos(va)))
			local movez = FixedMul(dist * 4 / 5, sin(va)) + (FRACUNIT / 2)
			P_MoveOrigin(mo, mo.target.x+movex, mo.target.y+movey, mo.target.z+movez)
			mo.frame = G+((leveltime%4)/2)|FF_FULLBRIGHT|alpha<<FF_TRANSSHIFT
			mo.color = SKINCOLOR_MAROON
		end
	end
end, MT_XSNAPLASTORBITSHOT)

------------------
-- MISFIRE MOBJ --
------------------
mobjinfo[MT_XSNAPMISFIRE] = {
	spawnstate = S_XSNAPMISFIRE,
	seesound = sfx_cblemp,
	deathstate = S_NULL,
	deathsound = sfx_None,
	speed = 64*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 24*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY
}
states[S_XSNAPMISFIRE] = {SPR_CBPF, A|FF_FULLBRIGHT|FF_ANIMATE, 14, nil, 7, 2, S_NULL}

local function GetGun(p,i)
	xItemLib.func.xItem_setPlayerItemCooldown(p, TICRATE/2)
	p.cbl = {timer = (10*TICRATE), rounds = 7, reload = false ,cooldown = 0}
end

local function GunFire(p, cmd, ticHeld, JustDown)
	if p.cbl then
		if not p.cbl.cooldown then
			if p.cmd.buttons & BT_ATTACK and p.cbl.timer then
				if p.cbl.timer == 10 * TICRATE then
					p.cbl.timer = $ - 1
				end
				if p.cbl.rounds > 1 then
					local bullet = RS_ShootBullet(p, true, MT_XSNAPSHOT, 0)
					bullet.scale = 2*mapobjectscale
					bullet.color = SKINCOLOR_YELLOW
				elseif p.cbl.rounds == 1 then
					local bullet = RS_ShootBullet(p, true, MT_XSNAPLASTSHOT, 0)
					bullet.scale = 2*mapobjectscale
					bullet.color = SKINCOLOR_YELLOW
					p.cbl.timer = max($-(TICRATE), 0)
					
					if p.cbl.timer == 0 then
						p.cbl = nil
						p.kartstuff[k_itemamount] = $ - 1
						return
					end
				else
					local bullet = RS_ShootBullet(p, true, MT_XSNAPMISFIRE, 0)
				end
				
				p.cbl.rounds = max($ - 1, 0)
				p.cbl.reload = true
			end
			p.cbl.cooldown = 5
		else
			p.cbl.cooldown = max($-1, 0)
		end
	else
		return
	end
end

local function DrawSnapTimer(v,p,c)
	if p.cbl.timer < 10 * TICRATE then
		p.xItemData.xItem_timerBar = p.cbl.timer or 0
		p.xItemData.xItem_maxTimerBar = 10*TICRATE
	end
	xItemLib.func.hudDrawItem(v, p, c)
end

local function SnapTimerHandler(p)
	if p.cbl then
		if p.kartstuff[k_position] > 1 then
			p.kartstuff[k_speedboost] = max($, FRACUNIT/4)
		end
		if p.cbl.timer > 0 and p.cbl.timer < (10*TICRATE) then
			p.cbl.timer = max($-1, 0)
			if p.cbl.timer == 0 then
				p.cbl = nil
				p.kartstuff[k_itemamount] = $ - 1
				return
			end
		end
	
		if p.cbl.reload and not (p.cmd.buttons & BT_ATTACK) then
			S_StartSound(p.mo, sfx_cblrld, p)
			xItemLib.func.xItem_setPlayerItemCooldown(p, TICRATE)
			p.cbl.rounds = 7
			p.cbl.reload = nil
			p.cbl.cooldown = 0
		end

	else 
		return
	end
end
addHook("PlayerThink", SnapTimerHandler)

if xItemLib then
	xItemLib.func.addItem{
	"XITEM_SNAPBLASTER", //Namespace
	"Chameleon Blaster", //Friendly Name
	"K_ITCBL", //HUD Graphic
	"K_ISCBL", //HUD Small Graphic
	XIF_COOLDOWNONSTART|XIF_POWERITEM|XIF_COLPATCH2PLAYER, //Flags
	{ 0, 0, 0, 1, 3, 2, 0, 0, 0, 0 }, //Race Odds
	{2, 1}, //Battle Odds
	GetGun, //Get Item Function
	nil, //Use Item Function
	DrawSnapTimer, //HUD Item Function
	false, //Itemodds overrides
	false, //Result Item Function
	{0, {SPR_XCBL,A}}, //Dropped Item Frames
	true, //Show in the item roulette
	GunFire, //Pre-use Function
	nil}
end