-- EMERGENCY CODE: AVOID aka "No Contest on Hit"

if (dd_avoidinit) then return end

local starttime = 6*TICRATE + (3*TICRATE/4)

rawset(_G, "dd_pcount", function()
	local count = 0
	for p in players.iterate
		count = $ + 1
	end
	
	return count
end)

rawset(_G, "dd_pcount2", function()
	local count = 0
	for p in players.iterate
		if p.spectator then continue end
		count = $ + 1
	end
	
	return count
end)

rawset(_G, "dd_pcount3", function()
	local count = 0
	for p in players.iterate
		if p.spectator or p.pflags & PF_TIMEOVER then continue end
		count = $ + 1
	end
	
	return count
end)

local function DD_PlayerDeath(p, source)
	if p.exiting then return end
	if p.pflags & PF_TIMEOVER then return end
	
	if not source then source = p end
	
	p.exiting = 0
	p.lives = 0
	p.pflags = $|PF_TIMEOVER
	p.hmt_eliminated = 1
	p.kartstuff[k_position] = dd_pcount2()
	p.kartstuff[k_growshrinktimer] = 0
	p.kartstuff[k_invincibilitytimer] = 0
	p.kartstuff[k_hyudorotimer] = 6*TICRATE
	p.dd_dead = 1
	if HugeQuest and p.hugequest then
		p.hugequest.huge = 0
		p.hugequest.sparkle = 0
	end
	P_DamageMobj(p.mo, nil, nil, 10000)

	-- rub it in
	S_ChangeMusic("KRFAIL", true, p)
	
	-- spawn KABOOM because it doesnt spawn one
	local boom = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_FZEROBOOM)
	boom.scale = p.mo.scale
	boom.angle = p.mo.angle
	-- combi interop
	if hcombi then
		if p.has_partner then
			DD_PlayerDeath(p.combi_p, source)
		end
	end
end

local function DD_DamageHandler(p)
	if server.XITdoomsday ~= "Avoid" then return end
	DD_PlayerDeath(p)
end

local function DD_PitHandler(p)
	if p.spectator then return end
	if leveltime < starttime then return end
	if server.XITdoomsday ~= "Avoid" then return end
	
	if p.playerstate == PST_DEAD and not (p.pflags & PF_TIMEOVER) then
		DD_PlayerDeath(p)
	end
end

local function DD_HUDCountdown(p)
	if leveltime < starttime then
		p.dd_dead = 0
		p.deathcountdown = 0
		return
	end
	if (p.pflags & PF_TIMEOVER) and p.dd_dead then
		p.deathcountdown = ($ or 0) + 1
		if p.deathcountdown == 1 then
			DoomsdayUtils.AddTooltip(p,"Emergency Trial failed!",nil)
		end
	end
end

addHook("PlayerThink", DD_PitHandler)
addHook("PlayerThink", DD_HUDCountdown)
addHook("PlayerSpin", DD_DamageHandler)
addHook("PlayerExplode", DD_DamageHandler)
addHook("PlayerSquish", DD_DamageHandler)

local function DD_SpinHandler(p, inf, source)
	if server.XITdoomsday ~= "Avoid" then return end
	return true
end

local function DD_ExplodeHandler(p, inf, source)
	if server.XITdoomsday ~= "Avoid" then return end
	return true
end

local function DD_ShouldDamage(mo, inf, source, damage)
	if not (mo and mo.valid and mo.player) then return end
	if server.XITdoomsday ~= "Avoid" then return end

	local mop, mopks = mo.player, mo.player.kartstuff
	
	-- reduce the amount of PlayerDamage hooks
	if damage >= 10000 then 
		if not (inf and inf.type == MT_SINK) then DD_PlayerDeath(mop) return end
	end -- for pits and respawns. we got that covered
	
	return
end

--addHook("ShouldSpin", DD_SpinHandler)
--addHook("ShouldExplode", DD_ExplodeHandler)
addHook("ShouldDamage", DD_ShouldDamage)

local countdown = 5*TICRATE
local countdown_2 = 0

addHook("NetVars", function(net)
	countdown = net(countdown)
	countdown_2 = net(countdown_2)
end)

local function DD_AllDead()
	-- make sure it aint running spb attack
	if server.SPBArunning then return end -- dont handle this when spb attack is already running
	if not server.XITdoomsday then return end
	if dd_pcount2() <= 0 then return end -- whats the point on running if there are actually no players
	if dd_pcount3() <= 0 then -- IF we actually have no players left
		countdown = $ - 1
		countdown_2 = $ + 1
	end
	
	if countdown_2 == 3 then
		for player in players.iterate
			DoomsdayUtils.AddTooltip(player,"\174Quest Failed! Restarting...", nil)
		end
	end
	
	if countdown <= 0 then
		countdown = 5*TICRATE
		countdown_2 = 0
		server.XITdoomsday = 0
		COM_BufInsertText(server, "map "..G_BuildMapName(gamemap))
	end
end
addHook("ThinkFrame", DD_AllDead)

addHook("MapChange", function()
	countdown = 5*TICRATE
	countdown_2 = 0
end)

rawset(_G, "dd_avoidinit", 1)