local TICRATE = TICRATE
local FRACUNIT = FRACUNIT
local ANG1 = ANG1
local k_itemamount = k_itemamount
local k_spinouttimer = k_spinouttimer

--item flags
local XIF_POWERITEM = 1 --is power item (affects final odds)
local XIF_COOLDOWNONSTART = 2 --can't be obtained on start cooldown
local XIF_UNIQUE = 4 --only one can exist in anyone's slot
local XIF_LOCKONUSE = 8 --locks the item slot when the item is used, slot must be unlocked manually by setting player.xItemData.xItem_itemSlotLocked to false
local XIF_COOLDOWNINDIRECT = 16 --checks if indirectitemcooldown is 0
local XIF_COLPATCH2PLAYER = 32 --map hud patch colour to player prefcolor
local XIF_ICONFORAMT = 64 --item icon changes depending on the item amount (animation frames become amount frames)

rawset(_G, "dd_debugmode" , CV_RegisterVar({
	name = "dd_debugmode",
	defaultvalue = "0",
	flags = CV_NETVAR,
	PossibleValue = {MIN = 0, MAX = 4}
}))

rawset(_G, "dd_debugmath" , CV_RegisterVar({
	name = "dd_debugmath",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}))

freeslot(
	"sfx_ddnuk1",
	"sfx_ddnuk2",
	"sfx_ddnuk3",
	"sfx_ddchg1",
	"sfx_ddchg2",
	"sfx_ddchg3",
	"sfx_ddget",
	"sfx_ddpass",
	"sfx_ddfail",
	"sfx_ddclr1",
	"sfx_ddclr2",
	"sfx_ddclr3",
	"sfx_ddclr4",
	"SPR_DDAY",
	"MT_JUDGMENTSOUND",
	"MT_JUDGMENTFIRE",
	"SPR_DDWC",
	"S_DDAYWARNING",
	"MT_DDAYWARNING",
	"MT_DDWARNCENTER",
	"SPR_DDYL",
	"S_DDAYLASER",
	"MT_DDAYLASER"
)
for i = 1, 12
	freeslot("S_JUDGMENTFIRE"..i)
end

for i = 1, 7
	freeslot("sfx_drkfz"..i)
end

states[S_DDAYWARNING] = {SPR_DDWC, FF_FULLBRIGHT|A, -1, nil, 0, 0, S_DDAYWARNING}
states[S_DDAYLASER] = {SPR_DDYL, FF_FULLBRIGHT|FF_ANIMATE|A, 8, nil, 7, 1, S_NULL}
states[S_JUDGMENTFIRE1] = {SPR_FZBM, FF_FULLBRIGHT, 2, nil, 0, 0, S_JUDGMENTFIRE2}
states[S_JUDGMENTFIRE2] = {SPR_FZBM, FF_FULLBRIGHT|1, 2, nil, 0, 0, S_JUDGMENTFIRE3}
states[S_JUDGMENTFIRE3] = {SPR_FZBM, FF_FULLBRIGHT|2, 2, nil, 0, 0, S_JUDGMENTFIRE4}
states[S_JUDGMENTFIRE4] = {SPR_FZBM, FF_FULLBRIGHT|3, 2, nil, 0, 0, S_JUDGMENTFIRE5}
states[S_JUDGMENTFIRE5] = {SPR_FZBM, FF_FULLBRIGHT|2, 1, A_FZBoomSmoke, 0, 0, S_JUDGMENTFIRE6}
states[S_JUDGMENTFIRE6] = {SPR_FZBM, FF_FULLBRIGHT|1, 1, A_FZBoomSmoke, 0, 0, S_JUDGMENTFIRE7}
states[S_JUDGMENTFIRE7] = {SPR_NULL, 0, 1, A_FZBoomSmoke, 1, 0, S_JUDGMENTFIRE8}
states[S_JUDGMENTFIRE8] = {SPR_NULL, 0, 1, A_FZBoomSmoke, 2, 0, S_JUDGMENTFIRE9}
states[S_JUDGMENTFIRE9] = {SPR_NULL, 0, 1, A_FZBoomSmoke, 3, 0, S_JUDGMENTFIRE10}
states[S_JUDGMENTFIRE10] = {SPR_NULL, 0, 1, A_FZBoomSmoke, 2, 0, S_JUDGMENTFIRE11}
states[S_JUDGMENTFIRE11] = {SPR_NULL, 0, 1, A_FZBoomSmoke, 1, 0, S_JUDGMENTFIRE12}
states[S_JUDGMENTFIRE12] = {SPR_NULL, 0, 1, A_FZBoomSmoke, 0, 0, S_NULL}

local ddaycooldown = 0
local numstarposts = -1 
addHook("NetVars", function(net)
	ddaycooldown = net($)
	numstarposts = net($)
end)

local function DD_SetCooldown(num)
	ddaycooldown = num*TICRATE
end

mobjinfo[MT_JUDGMENTSOUND] = {
	doomednum = -1,             // doomednum
	spawnstate = S_INVISIBLE,    // spawnstate
	spawnhealth = 1,            // spawnhealth
	seestate = S_NULL,         // seestate
	seesound = sfx_None,       // seesound
	reactiontime = 8,              // reactiontime
	attacksound = sfx_None,       // attacksound
	painstate = S_NULL,         // painstate
	speed = 0,              // speed
	radius = 16*FRACUNIT,    // radius
	radius = 16*FRACUNIT,    // height
	mass = 100,            // mass
	damage = 0,              // damage
	activesound = sfx_None,       // activesound
	flags = MF_NOBLOCKMAP|MF_NOSECTOR|MF_NOGRAVITY // flags
}

mobjinfo[MT_DDWARNCENTER] = {
	doomednum = -1,             // doomednum
	spawnstate = S_INVISIBLE,    // spawnstate
	spawnhealth = 1,            // spawnhealth
	seestate = S_NULL,         // seestate
	seesound = sfx_None,       // seesound
	reactiontime = 8,              // reactiontime
	attacksound = sfx_None,       // attacksound
	painstate = S_NULL,         // painstate
	speed = 0,              // speed
	radius = 16*FRACUNIT,    // radius
	radius = 16*FRACUNIT,    // height
	mass = 100,            // mass
	damage = 0,              // damage
	activesound = sfx_None,       // activesound
	flags = MF_NOBLOCKMAP|MF_NOSECTOR|MF_NOGRAVITY // flags
}

mobjinfo[MT_JUDGMENTFIRE] = {           // MT_FZEROBOOM
	doomednum = -1,             // doomednum
	spawnstate = S_INVISIBLE,    // spawnstate
	spawnhealth = 1000,           // spawnhealth
	seestate = S_NULL,         // seestate
	seesound = sfx_kc31,       // seesound
	reactiontime = 8,              // reactiontime
	attacksound = sfx_kc51,       // attacksound
	painstate = S_NULL,         // painstate
	speed = 0,              // speed
	ridaus = FRACUNIT,       // radius
	height = FRACUNIT,       // height
	dispoffset = 0,              // display offset
	mass = 0,              // mass
	damage = 0,              // damage
	activesound = sfx_None,       // activesound
	flags = MF_ENEMY|MF_SPECIAL, // flags
}

mobjinfo[MT_DDAYWARNING] = {
	spawnstate = S_DDAYWARNING,
	spawnhealth = 1000,
	radius = FRACUNIT,
	height = FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_DONTENCOREMAP|MF_NOCLIP
}

-- Reimplemented FZEROBOOM because a) I like having my eyesight intact and
-- b) The horizontal momentum from vanilla boom doesn't fit well with
-- random angle stuff during DISASTER

local function DD_FirePillar(mo)
	if not (mo and mo.valid) then return end
	if not mo.extravalue2 then mo.extravalue2 = 0 end

	if not mo.extravalue1 then
		/*
		if server.ddjudgmentmode == 1 then
			local explosion = P_SpawnMobj(mo.x, mo.y, mo.z+(mo.height/2), MT_THOK)

			explosion.state = S_JUDGMENTFIRE1
			explosion.scale = mo.scale

			--S_StartSound(mo, mo.info.seesound)
		end
		*/
		mo.extravalue1 = 1
	end

	if not S_SoundPlaying(mo, mo.info.attacksound) then
		S_StartSoundAtVolume(mo, mo.info.attacksound, 160)
	end

	if mo.extravalue2 <= 8 // Short delay
		mo.extravalue2 = $+1 // flametimer
	else // fire + smoke pillar
		if leveltime%3 == 0 then
			local fire = P_SpawnMobj(mo.x + (P_RandomRange(-32, 32)*mo.scale), mo.y + (P_RandomRange(-32, 32)*mo.scale), mo.z, MT_THOK)

			fire.sprite = SPR_FPRT
			fire.frame = FF_FULLBRIGHT|FF_TRANS30
			fire.scale = mo.scale*4
			fire.momz = P_RandomRange(2, 3)*mo.scale
			fire.scalespeed = mo.scale/12
			fire.destscale = 1
			if server.XITdoomsday == "Disaster" then
				fire.color = SKINCOLOR_BLUE
			else
				fire.color = SKINCOLOR_RED
			end
			fire.colorized = true
			fire.flags = $|MF_ENEMY|MF_SPECIAL
			fire.tics = TICRATE

			for i = 0, 1
				local smoke = P_SpawnMobj(mo.x + (P_RandomRange(-16, 16)*mo.scale), mo.y + (P_RandomRange(-16, 16)*mo.scale), mo.z, MT_SMOKE)

				mo.state = S_FZSLOWSMOKE1
				smoke.scale = mo.scale
				smoke.momz = P_RandomRange(3, 10)*mo.scale
				smoke.destscale = mo.scale*4
				smoke.scalespeed = mo.scale/24
				if server.XITdoomsday == "Disaster2" then
					smoke.color = SKINCOLOR_MAROON
				else
					smoke.color = SKINCOLOR_THUNDER
				end
				smoke.colorized = true
			end
		end
	end
end
addHook("MobjThinker", DD_FirePillar, MT_JUDGMENTFIRE)

-- This is specifically so AVOID doesn't tank frames from everyone dying
addHook("MobjSpawn", function(mo)
	mo.fuse = 3*TICRATE
end, MT_FZEROBOOM)

-- This checks for whether an object would spawn in a wall/impassable linedef
-- and ultimately moves it somewhere in open space.

local function getNormalizedVectors(x, y)
    local angle = R_PointToAngle2(0, 0, x, y)
    return FixedMul(1*FRACUNIT, cos(angle)), FixedMul(1*FRACUNIT, sin(angle))
end

-- Thanks Ashnal!
local function Clamp(value, newmin ,newmax)
	return min(newmax,max(newmin,value))
end

local function DD_NearPoint(line, mo)
	local lineX, lineY = line.v2.x - line.v1.x, line.v2.y - line.v1.y
	--print("LineX, LineY: "..lineX..", "..lineY)
	local length = R_PointToDist2(line.v1.x, line.v1.y, line.v2.x, line.v2.y)

	lineX, lineY = getNormalizedVectors(lineX, lineY)
	--print("Normalized LineX, LineY: "..lineX..", "..lineY)

	local vX = mo.x - line.v1.x
	local vY = mo.y - line.v1.y
	--print("Secondary vector: "..vX..", "..vY)
	
	
	local angle = R_PointToAngle2(vX, vY, lineX, lineY)
	--print("Angle: "..angle/ANG1)

	local A = FixedSqrt(abs((FixedMul(vX, vX) + FixedMul(vY, vY))))
	local B = FixedSqrt(abs((FixedMul(lineX, lineX) + FixedMul(lineY, lineY))))
	local d = A * B * cos(angle)
	d = Clamp($, 0, length)
	
	return line.v1.x + FixedMul(lineX, d), line.v1.y + FixedMul(lineY, d)
end

local function DD_FuckWalls(spawn, x, y, z)
	local mo = P_SpawnMobj(x, y, z, spawn)

	if not P_TryMove(mo, x, y) then
		--print("Initial move failed")
		local subsector = R_PointInSubsector(x, y)
		local sec = subsector.sector
		local radius = FixedMul(200*FRACUNIT, mapobjectscale)

		-- Bless Juggy because hoooolyyyy shit I never would've
		-- figured this out on my own.

		for i = 0, #sec.lines-1
			local newx, newy = DD_NearPoint(sec.lines[i], mo)
			
			local dist = R_PointToDist2(x, y, newx, newy)
			
			local finalX = (x + 2*dist)
			local finalY = (y + 2*dist)
			if P_CheckPosition(mo, finalX, finalY) then
				--print("New valid coordinates")
				P_SetOrigin(mo, finalX, finalY, z)
				--S_StartSound(mo, sfx_itemup)
				break
			end
		end
	end
	
	return mo
end

local function DD_RocketDrop(x, y, z)
	local subsector = R_PointInSubsector(x, y)
	local sec = subsector.sector
	local special = sec.special

	-- Don't spawn in sectors with deathpits or sky textures
	if (GetSecSpecial(special, 1) >= 6 and GetSecSpecial(special, 1) <= 8) 
	or sec.floorpic == "F_SKY" then
		return
	end
	
	local rocket = DD_FuckWalls(MT_VERTLROCKET, x, y, z)
	rocket.color = SKINCOLOR_KETCHUP
end

-- I like how Elim does the warning orbit thing around players, so let's
-- also do that for DISASTER beams!

local function cSpd(ang, spd, mo)
	if mo == nil then mo = {scale=FRACUNIT} end
	spd = FixedMul(spd, mo.scale)
	return FixedMul( cos(ang), spd ), FixedMul( sin(ang), spd )
	--returns x and y of calc
end

local function DD_Orbiter(actor)
	if not (actor and actor.valid) then return end

	if not (actor.DDorbit and actor.DDorbit.valid) then
		actor.fuse = 40
		for i = 1, 8 do
			local e = P_SpawnMobj(actor.x, actor.y, actor.z, MT_DDAYWARNING)
			e.target = actor
			e.colorized = true
			e.angmod = ANGLE_45 * i
			if i == 1 then
				actor.DDorbit = e
			end
		end
	end
end

-- This is now a 2-part hazard where the warning first spawns, then the beam
-- strike once the fuse on the warning expires. Makes driving more fair in 
-- DISASTER and puts the Emergency Code on par with EXPLOSION in terms of
-- difficulty.
local function JudgmentWarning(x, y, z, grounded)
	local subsector = R_PointInSubsector(x, y)
	local sec = subsector.sector
	local special = sec.special

	-- Don't spawn in sectors with deathpits or sky textures
	if (GetSecSpecial(special, 1) >= 6 and GetSecSpecial(special, 1) <= 8) 
	or sec.floorpic == "F_SKY" then
		return
	end

	--local actor = P_SpawnMobj(x, y, z, MT_DDWARNCENTER)
	local actor = DD_FuckWalls(MT_DDWARNCENTER, x, y, z)
	
	if (not P_IsObjectOnGround(actor))
	or z < actor.floorz then
		P_SetOrigin(actor, x, y, actor.floorz)
	end

	actor.DDfinalspawn = true
end

local function DD_WarnThinker(mo)
	if mo.DDactive == nil then mo.DDactive = 0 end
	
	mo.DDactive = $+1
	mo.color = leveltime%7 > 3 and SKINCOLOR_RED or SKINCOLOR_BLUE
	if (mo and mo.valid) and mo.DDactive > 1 then
		if mo.target and mo.target.valid and mo.target.DDorbit then
			local t = mo.target
			
			local thisAng = leveltime*(ANG2*3)
			local x,y = cSpd(thisAng+mo.angmod, (t.fuse*6)*FRACUNIT, t)
			P_MoveOrigin(mo, t.x+x, t.y+y, t.z)
		else
			P_RemoveMobj(mo)
			return
		end
	end
end
addHook("MobjThinker", DD_WarnThinker, MT_DDAYWARNING)

local function Judgment(x, y, z)
	--print("DED")
	local vbolt
	local hbolt
	local rbolt
	local sx
	local sy
	local an
	local radius = FixedMul(160*FRACUNIT, mapobjectscale)
	local actor = P_SpawnMobj(x, y, z, MT_THOK)
	local sound = P_SpawnMobj(x, y, z, MT_JUDGMENTSOUND)
	
	/*
	if server.ddjudgmentmode == 1 then
		P_NukeEnemies(actor, actor, radius)
	elseif server.ddjudgmentmode == 2 then
		A_BurstRing(actor)
	end
	*/
	
	--A_BurstRing(actor)
	P_NukeEnemies(actor, actor, radius)

	// spawn beam
	vbolt = P_SpawnMobj(x, y, z, MT_THOK)
	vbolt.target = actor
	vbolt.state = S_DDAYLASER
	vbolt.scale = actor.scale*5
	if server.XITdoomsday == "Disaster2" then
		vbolt.color = SKINCOLOR_MAROON
	else
		vbolt.color = SKINCOLOR_CYAN
	end
	
	if server.XITdoomsday == "Disaster"
	or server.XITdoomsday == "Disaster2" then
		local fire = P_SpawnMobj(x, y, z, MT_JUDGMENTFIRE)
		fire.fuse = 3*TICRATE
	end
end

local function DD_Strike(mo)
	if not (mo and mo.valid) then return end

	if mo.DDfinalspawn then
		DD_Orbiter(mo)
	end

	if mo.fuse == 1 then
		Judgment(mo.x, mo.y, mo.z)
	end
end
addHook("MobjThinker", DD_Strike, MT_DDWARNCENTER)

local function thunderclap(mo)
	if not mo and mo.valid then return end
	
	if mo.health
	and not mo.ddthunder
		S_StartSound(mo, sfx_s3k54)
		mo.ddthunder = true
	end
	
	if mo.ddthunder
	and not S_SoundPlaying(mo, sfx_s3k54) then
		P_KillMobj(mo)
	end
end
addHook("MobjThinker", thunderclap, MT_JUDGMENTSOUND)

addHook("MusicChange", function(old, new, mflags, looping, position, prefadems, fadems)
	if not server.XITdoomsday then return end
	
	new = new:upper()
	old = old:upper()
	
	if (old == "XIDD1" or old == "XIDD2" or old == "XIDD3" or old == "DDFALZ")
	and not (new == "XIDD1" or new == "XIDD2" or new == "XIDD3" or new == "DDFALZ" or new == "KRFAIL") then
		return true
	end
	
	if (old == "KGROW" or old == "KINVNC" or old == "HQSUPR")
	and (new == "XIDD1" or new == "XIDD2" or new == "XIDD3" or new == "DDFALZ") then
		return new
	end
	
end)

addHook("MobjThinker", function(starpost)
	if leveltime < 2 then return end
	if starpost.processed then return end
	if starpost.health > numstarposts  then
		numstarposts = starpost.health
		--print("Checkpoint count is now: "..numstarposts)
	end
	starpost.processed = true

end, MT_STARPOST)

local function reset()
  numstarposts = -1
end

addHook("MapChange",reset)
addHook("MapLoad",reset)

local function DD_ANGDiff(mo)
	if leveltime < 236 then return end
	if not (mo and mo.valid and mo.player) then return end
	if mo.ddangdiff == nil then mo.ddangdiff = 0 end
	if mo.ddlastang == nil then mo.ddlastang = 0 end
	local p = mo.player
	
	local newmomangle = R_PointToAngle2(0, 0, mo.momx, mo.momy)
	
	mo.ddthrustforce = R_PointToDist2(0, 0, mo.momx, mo.momy)
	mo.ddangdiff = newmomangle - mo.ddlastang
	mo.ddlastang = newmomangle
	
	--print(mo.ddthrustforce.."/"..mo.ddangdiff.."/"..mo.ddlastang)
end
addHook("MobjThinker", DD_ANGDiff, MT_PLAYER)

local ddaytable = {
	[1] = {"Explosion", sfx_ddnuk1, sfx_ddchg1, "XIDD1", 28},
	[2] = {"Disaster", sfx_ddnuk2, sfx_ddchg2, "XIDD2", 11},
	[3] = {"Avoid", sfx_ddnuk3, sfx_ddchg3, "XIDD3", 1017},
	[4] = {"Disaster2", sfx_ddnuk2, sfx_ddchg2, "DDFALZ", 28}
}

local changeovertable = {
	["Explosion"] = {ddaytable[2], ddaytable[3], ddaytable[4]},
	["Disaster"] = {ddaytable[1], ddaytable[3], ddaytable[4]},
	["Avoid"] = {ddaytable[1], ddaytable[2], ddaytable[4]} ,
	-- for debugging purposes
	["Disaster2"] = {ddaytable[4], ddaytable[4], ddaytable[4]} 
}

local battlechangeover = {
	["Explosion"] = {ddaytable[2], ddaytable[4]},
	["Disaster"] = {ddaytable[1], ddaytable[4]}
}

local function ddayroulette()
	if server.XITdoomsday then
		if G_RaceGametype()
			return changeovertable[server.XITdoomsday][P_RandomRange(1, 3)]
		else
			return battlechangeover[server.XITdoomsday]
		end
	else
		if G_RaceGametype() then
			return ddaytable[P_RandomRange(1, #ddaytable)]
		else
			return ddaytable[P_RandomRange(1, 2)]
		end
	end
end

local function useDoomsday(p, cmd)
	local Ddaymode = ddayroulette()
	
	-- Last thing you'd want is dying after triggering AVOID because you
	-- fell into a pit off a botched jump
	if P_IsObjectOnGround(p.mo) then
		if dd_debugmode.value then
			Ddaymode = ddaytable[dd_debugmode.value]
		end
	
		server.XITdoomsday = Ddaymode[1]
		if p.laps == nil then p.laps = 0 end

		local basetimer = max((FixedRound((180*FRACUNIT/(numlaps*numstarposts))*((numlaps*numstarposts) - (p.laps*numstarposts + p.starpostnum)))/FRACUNIT), 45)
		local speedadjust = (basetimer/12)*(2-gamespeed)
		local finaltimer = (basetimer + speedadjust)*TICRATE
		
		--print("Current: "..server.XITdoomsday.." Last: "..server.lastDday)
	
		if server.lastDday then
			if server.XITdoomsday ~= server.lastDday then
				server.XITdoomsdaychange = true
				server.XITdoomsdaychangetimer = racecountdown
				S_StartSound(nil, Ddaymode[3])
			end
		else
			S_StartSound(nil, Ddaymode[2])
		end

		--P_SwitchWeather(1)
		
		S_ChangeMusic(Ddaymode[4])
		P_SetupLevelSky(Ddaymode[5])

		p.kartstuff[k_itemamount] = $-1

		if not p.kartstuff[k_itemamount] then
			if K_IsPlayerLosing(p) and p.kartstuff[k_position] >= 10 then
				p.kartstuff[k_itemtype] = 2
				p.kartstuff[k_itemblinkmode] = 2
			elseif p.kartstuff[k_position] > 2
				p.kartstuff[k_itemtype] = 1
				p.kartstuff[k_itemamount] = 2
			elseif p.kartstuff[k_position] == 2 then
				p.kartstuff[k_itemtype] = 1
				p.kartstuff[k_itemamount] = 1
				p.kartstuff[k_itemblinkmode] = 1
			else
				p.kartstuff[k_driftboost] = $ + 50
			end
		end
	
		if Ddaymode[1] == "Avoid" then
			for q in players.iterate
				if q.spectator then continue end
				if q == p then continue end
				K_StripItems(q)
				K_StripOther(q)
				if HugeQuest and q.hugequest.huge > 0 then
					q.hugequest.huge = 1
				end
			end
		end
		
		for m in thinkers.iterate("mobj")
			if m and m.valid
				if (m.type == MT_FLOATINGITEM
				or m.type == MT_FLOATINGXITEM)
					P_RemoveMobj(m)
					continue	-- don't continue past this point
				end
				if ((m.flags & MF_MISSILE)
					or m.type == MT_SPB
					or m.type == MT_BANANA_SHIELD
					or m.type == MT_BANANA
					or m.type == MT_ORBINAUT_SHIELD
					or m.type == MT_ORBINAUT
					or m.type == MT_JAWZ_SHIELD
					or m.type == MT_JAWZ
					or m.type == MT_JAWZ_DUD
					or m.type == MT_SSMINE_SHIELD
					or m.type == MT_SSMINE
					or m.type == MT_SINK
					or m.type == MT_EGGMANITEM)
				and not (m.type == MT_PLAYER or m.type == MT_EXPLODINGBARREL)
					P_KillMobj(m)
				end	
			end
		end
		
		if server.XITdoomsday ~= server.lastDday then
			server.XITdoomflash = 0
			if G_RaceGametype()
			and not racecountdown then
				K_SetRaceCountdown(finaltimer)
				K_SetIndirectItemCooldown(finaltimer)
				server.XITdoomsdaytimer = finaltimer
				--print(indirectitemcooldown)
			end
		end

		if (hitfeed) then
			local s = {{p.name, p.mo.hf_overridenamecolor or p.skincolor}, {skins[p.mo.skin].facemmap, p.skincolor}, p}
			local v
			local icon = "K_HMDDAY"
			
			HF_SendHitMessage(s, v, icon)
		end
	
		DD_SetCooldown(30)
		--print(numstarposts)
	else
		S_StartSound(p.mo, sfx_buzz3, p)
		p.kartstuff[k_itemblinkmode] = 1
		p.kartstuff[k_itemblink] = TICRATE/2
	end
end

local function getDoomsday(p,i)
	S_StartSound(p.mo, sfx_ddget, p)
end

local function DoomsdayOdds(newodds, pos, mashed, rush, p, secondist, pingame, pexiting)
	local nod = newodds
	if ddaycooldown > 0
	or server.XITdoomsday == "Disaster2"
	or pexiting
	or rush
		nod = 0
	end
	return nod
end

local function DD_DisasterProc()
	if (racecountdown and racecountdown%P_RandomRange(20,70) == 0)
	or (not racecountdown and leveltime%P_RandomRange(20,70) == 0)
		return 1
	end
	
	return 0
end

local function DD_FalzTaunt()
	if server.XITdoomsday ~= "Disaster2" then
		return
	end

	if (racecountdown and racecountdown%P_RandomRange(5*TICRATE, 10*TICRATE) == 0) then
		return 1
	end

	return 0
end

local falzsounds = {
	sfx_drkfz1,
	sfx_drkfz2,
	sfx_drkfz3,
	sfx_drkfz4,
	sfx_drkfz5,
	sfx_drkfz6,
	sfx_drkfz7
}
local lastfalz = {
	[sfx_drkfz1] = {
		sfx_drkfz2,
		sfx_drkfz3,
		sfx_drkfz4,
		sfx_drkfz5,
		sfx_drkfz6,
		sfx_drkfz7
	},

	[sfx_drkfz2] = {
		sfx_drkfz1,
		sfx_drkfz3,
		sfx_drkfz4,
		sfx_drkfz5,
		sfx_drkfz6,
		sfx_drkfz7
	},

	[sfx_drkfz3] = {
		sfx_drkfz1,
		sfx_drkfz2,
		sfx_drkfz4,
		sfx_drkfz5,
		sfx_drkfz6,
		sfx_drkfz7
	},

	[sfx_drkfz4] = {
		sfx_drkfz1,
		sfx_drkfz2,
		sfx_drkfz3,
		sfx_drkfz5,
		sfx_drkfz6,
		sfx_drkfz7
	},

	[sfx_drkfz5] = {
		sfx_drkfz1,
		sfx_drkfz2,
		sfx_drkfz3,
		sfx_drkfz4,
		sfx_drkfz6,
		sfx_drkfz7
	},

	[sfx_drkfz6] = {
		sfx_drkfz1,
		sfx_drkfz2,
		sfx_drkfz3,
		sfx_drkfz4,
		sfx_drkfz5,
		sfx_drkfz7
	},

	[sfx_drkfz7] = {
		sfx_drkfz1,
		sfx_drkfz2,
		sfx_drkfz3,
		sfx_drkfz4,
		sfx_drkfz5,
		sfx_drkfz6
	}
}
local falzplay
addHook("NetVars", function(net)
	falzplay = net($)
end)

-- Shoutouts to Togen and Item Rain for making this possible!
local doomflash = {V_10TRANS, V_20TRANS, V_30TRANS, V_40TRANS, V_50TRANS, V_60TRANS, V_70TRANS}
local function DoomsdayHandler()
	if leveltime < 2 then return end
	
	if dd_debugmath.value
		for p in players.iterate
			if not (p == server) or IsPlayerAdmin(p) then continue end
			if (p.spectator) then continue end
			--print(p.name.." FloorZ: "..p.mo.floorz)
			--print(p.name.." FloorZAtPos: "..P_FloorzAtPos(p.mo.x, p.mo.y, p.mo.z, p.mo.height))
			--print("MomX: "..p.mo.momx/FRACUNIT)
			--print("MomY: "..p.mo.momy/FRACUNIT)
			if p.cmd.driftturn < 0 --Right drift
				CONS_Printf(p, "Right drift: "..p.cmd.driftturn)
			elseif p.cmd.driftturn > 0 -- Left drift
				CONS_Printf(p, "Left drift: "..p.cmd.driftturn)
			end
		end
	end
	
	if not server.XITdoomsday then return end

	if server.XITdoomsday == "Disaster2" then
		if server.ddlastfalz then
			falzplay = lastfalz[server.ddlastfalz][P_RandomRange(1, 6)]
		else
			falzplay = falzsounds[P_RandomRange(1, 7)]
			--print(falzplay)
		end
	end
	
	--print("Random Spawn value: "..DD_DisasterProc())
	if DD_DisasterProc()
	and server.XITdoomsday ~= "Avoid" then
		local racers = {} -- count number of active players, re-evaluate every tick to catch leavers/spectators
		
		for p in players.iterate
			if not p.spectator then 
				--if leveltime%TICRATE == 0 then
					--print("Ceiling: "..p.mo.ceilingz)
				--end
				if not K_IsPlayerLosing(p) then
					table.insert(racers, p)
				end
				if DD_FalzTaunt()
				and not (S_SoundPlaying(p.mo, sfx_drkfz1)
				or S_SoundPlaying(p.mo, sfx_drkfz2)
				or S_SoundPlaying(p.mo, sfx_drkfz3)
				or S_SoundPlaying(p.mo, sfx_drkfz4)
				or S_SoundPlaying(p.mo, sfx_drkfz5)
				or S_SoundPlaying(p.mo, sfx_drkfz6)
				or S_SoundPlaying(p.mo, sfx_drkfz7))
					S_StartSound(p.mo, falzplay, p)
					server.ddlastfalz = falzplay
				end
			end
		end
		local randomPlayer = racers[P_RandomRange(1, #racers)]

		if randomPlayer.mo and randomPlayer.mo.valid then
			local ipos
			local p = randomPlayer
			local pmo = p.mo
			local sx = pmo.momx*40
			local sy = pmo.momy*40
			local sr = FixedMul(pmo.radius*3, mapobjectscale)/FRACUNIT
			local sa = pmo.angle
			if G_RaceGametype() then
				if p.speed <= FixedMul(pmo.radius * 2, mapobjectscale) then
					sx = FixedMul(pmo.radius*20, cos(sa))
					sy = FixedMul(pmo.radius*20,sin(sa))
				end
				if server.XITdoomsday == "Explosion"
					if p.kartstuff[k_drift] ~= 0 then
						local st = (5*pmo.ddthrustforce)/4
						local sd = pmo.ddangdiff
						sa = R_PointToAngle2(0, 0, pmo.momx, pmo.momy)
						local trace = P_SpawnMobj(pmo.x, pmo.y,pmo.z, MT_THOK)
						for i = 1, 40
							P_MoveOrigin(trace, trace.x + FixedMul(st, cos(sa+sd*i)), trace.y + FixedMul(st, sin(sa+sd*i)) , trace.z)
						end
						ipos = {
							x = trace.x + (FixedMul(P_RandomRange(0, 127)*FRACUNIT, cos(sa + (sd*40) + (P_RandomRange(-90, 90)*ANG1)))),
							y = trace.y + (FixedMul(P_RandomRange(0, 127)*FRACUNIT, sin(sa + (sd*40) + (P_RandomRange(-90, 90)*ANG1)))),
							z = min(pmo.ceilingz - (pmo.height*2),pmo.z + pmo.scale*896)
						}
						if trace and trace.valid then
							P_KillMobj(trace)
						end
					else
						sx = (3*$)/2
						sy = (3*$)/2
						ipos = {
							x = pmo.x + sx + (FixedMul(FixedMul(P_RandomRange(0, 127)*FRACUNIT, mapobjectscale), cos(sa + (P_RandomRange(-90, 90)*ANG1)))), -- Item spawn has a random horizontal offset.
							y = pmo.y + sy + (FixedMul(FixedMul(P_RandomRange(0, 127)*FRACUNIT, mapobjectscale), sin(sa + (P_RandomRange(-90, 90)*ANG1)))),
							z = min(pmo.ceilingz - (pmo.height*2),pmo.z + pmo.scale*896)
						}
					end
				elseif  (server.XITdoomsday == "Disaster"
				or server.XITdoomsday == "Disaster2") then
					if p.kartstuff[k_drift] ~= 0 then
						local st = pmo.ddthrustforce
						local sd = pmo.ddangdiff
						sa = R_PointToAngle2(0, 0, pmo.momx, pmo.momy)
						local trace = P_SpawnMobj(pmo.x, pmo.y,pmo.z, MT_THOK)
						for i = 1, 40
							P_MoveOrigin(trace, trace.x + FixedMul(st, cos(sa+sd*i)), trace.y + FixedMul(st, sin(sa+sd*i)) , trace.z)
						end
						ipos = {
							x = trace.x + (FixedMul(P_RandomRange(0, 127)*FRACUNIT, cos(sa + (sd*40) + (P_RandomRange(-90, 90)*ANG1)))),
							y = trace.y + (FixedMul(P_RandomRange(0, 127)*FRACUNIT, sin(sa + (sd*40) + (P_RandomRange(-90, 90)*ANG1)))),
							z = min(trace.z + trace.height*2, trace.ceilingz)
						}
						if trace and trace.valid then
							P_KillMobj(trace)
						end
					else
						ipos = {
							x = pmo.x + sx + (FixedMul(P_RandomRange(0, 127)*FRACUNIT, cos(sa + (P_RandomRange(-90, 90)*ANG1)))),
							y = pmo.y + sy + (FixedMul(FixedMul(P_RandomRange(0, 127)*FRACUNIT, mapobjectscale), sin(sa + (P_RandomRange(-90, 90)*ANG1)))),
							z = min(pmo.z + pmo.height*2, pmo.ceilingz)
						}
					end
				end
			else
				if server.XITdoomsday == "Explosion" then
					ipos = {x = pmo.x + P_SignedRandom()*P_RandomRange(8,16)*FRACUNIT, -- Item spawn has a random horizontal offset.
										y = pmo.y + P_SignedRandom()*P_RandomRange(8,16)*FRACUNIT,
										z = min(pmo.ceilingz - (pmo.height*2),pmo.z + pmo.scale*320)}
				elseif (server.XITdoomsday == "Disaster"
				or server.XITdoomsday == "Disaster2") then
					ipos = {x = pmo.x + P_SignedRandom()*P_RandomRange(4,8)*FRACUNIT, -- Item spawn has a random horizontal offset.
										y = pmo.y + P_SignedRandom()*P_RandomRange(4,8)*FRACUNIT,
										z = min(pmo.z +pmo.height*2, pmo.ceilingz)}
				end
			end
			
			if server.XITdoomsday == "Explosion" then
				DD_RocketDrop(ipos.x, ipos.y, ipos.z)
			elseif (server.XITdoomsday == "Disaster"
				or server.XITdoomsday == "Disaster2") then
				JudgmentWarning(ipos.x, ipos.y, ipos.z)
			end
		end
	end
	
	if leveltime%(TICRATE/7) == 0 then
		if server.XITdoomflash < #doomflash then
			server.XITdoomflash = $ + 1
		end
	end
	
	ddaycooldown = max($-1, 0)
	server.lastDday = server.XITdoomsday
end
addHook("ThinkFrame", DoomsdayHandler)

addHook("MapLoad", function()
	server.XITdoomsday = 0
	server.XITdoomflash = 0
	server.lastDday = 0
	server.XITdoomsdaychange = false
	server.ddlastfalz = 0
	ddaycooldown = 0
end)

addHook("VoteThinker", function()
	server.lastDday = 0
	server.XITdoomsday = 0
end)

local splitplayers = {}
local function splitnum(p)
	for i = 1, #splitplayers do
		if splitplayers[i] == p then
			return i-1
		end
	end
end

local DDay_Overlay = {
	["Explosion"] = 
		{fade = "DDOVRLY1", text = "TEX2", tooltip = "\151ATAQUE AEREO NA PISTA! SE PROTEJA!"},
	["Disaster"] = 
		{fade = "DDOVRLY2", text = "TEX3", tooltip = "\198DESVIE DOS LASERS DA LAGOSTA AZUL!"},
	["Avoid"] = 
		{fade = "DDOVRLY3", text = "TEX4", tooltip = "\220EVITE SER ATINGIDO OU CAIR!"},
	["Disaster2"] = 
		{fade = "DDOVRLY1", text = "TEX3", tooltip = "<\\shake>\151SOBREVIVA A IRA DA LAGOSTA AZUL!<\\shake>"}
}


local background = {x = 0,y = 65 * FRACUNIT} 
local emergency = {x = 0,y = 165 * FRACUNIT / 2} 
local dday_type = {x = 0,y = 205 * FRACUNIT / 2}

local bg_appear = TICRATE -- When Main Bar's Enter Slide Finishes
local bg_wait = bg_appear + (2 * TICRATE) -- When Main Bar's Leave Slide Starts
local bg_gone = bg_wait + (TICRATE) -- When Main Bar's Leave Slide Finishes

addHook("ThinkFrame", function()
	local ticker
	if server.XITdoomsdaychange then
		ticker = server.XITdoomsdaychangetimer
	else
		ticker = server.XITdoomsdaytimer
	end
	if not ticker then return end
	local cur_doom = DDay_Overlay[server.XITdoomsday]
	if (ticker - racecountdown) == (bg_gone + 1) then
		for player in players.iterate 
			if not(player.pflags & PF_TIMEOVER) and not player.exiting 
			and cur_doom then
				DoomsdayUtils.AddTooltip(player,cur_doom.tooltip, 5 * TICRATE)
			end
		end
	end
end)

hud.add(function(v, p, c)
	if not server.XITdoomsday then return end
	
	local ticker_start
	if server.XITdoomsdaychange then
		ticker_start = server.XITdoomsdaychangetimer
	else
		ticker_start = server.XITdoomsdaytimer
	end
	
	local hud_ticker = ticker_start - racecountdown

	local time_o = 0
	local time_t = 0
	local time_percent = 0
	
	--print(((basetime-(racecountdown/TICRATE))/10))
	splitplayers[#splitplayers+1] = p
	
	if (not splitscreen) or (splitscreen and splitnum(p) == 0) then
		if server.XITdoomflash then
			v.drawScaled(0,0,1024 * FRACUNIT, v.cachePatch(DDay_Overlay[server.XITdoomsday].fade), V_SNAPTOTOP|V_SNAPTOLEFT|doomflash[server.XITdoomflash])
			
			local prefix = "DDAY"
			local color = SKINCOLOR_JAWZ
			local code = "TEX0"
			if server.XITdoomsdaychange then
				color = SKINCOLOR_YELLOW
				code = "TEX1"
			end
			
			if server.XITdoomsday == "Disaster2" then
				color = SKINCOLOR_CRIMSON
			end
			
			local cachedColor = v.getColormap(TC_DEFAULT, color)
			
			--Background Elements
			if hud_ticker <= bg_appear then
				time_t = bg_appear
				time_o = 0
				time_percent = hud_ticker * FRACUNIT / time_t
				
				background.x = SolEasing.OutSine(time_percent, 512 * FRACUNIT, 16 * FRACUNIT)
			elseif hud_ticker > bg_wait and hud_ticker <= bg_gone then
				time_t = bg_gone - bg_wait
				time_o = bg_wait
				time_percent = (hud_ticker - time_o) * FRACUNIT / time_t
				
				background.x = SolEasing.InSine(time_percent, 16 * FRACUNIT, 512 * FRACUNIT)
			end
			if racecountdown then
				v.drawScaled(background.x,background.y, FRACUNIT, v.cachePatch(string.format(prefix.."B%02d",(hud_ticker % 12) + 1)), V_SNAPTOTOP|V_40TRANS, cachedColor)
				v.drawScaled(background.x,background.y, FRACUNIT, v.cachePatch(prefix.."A01"), V_SNAPTOTOP|V_40TRANS, cachedColor)
				local egg_trans = V_60TRANS
				if hud_ticker % 2 then egg_trans = V_20TRANS end
				v.drawScaled(background.x,background.y + (37*FRACUNIT/2), FRACUNIT, v.cachePatch(prefix.."EGG"), V_SNAPTOTOP|egg_trans, cachedColor)
			end
			
			--Emergency Text
			if hud_ticker <= bg_gone then
				time_t = bg_gone + (TICRATE / 7)
				time_o = bg_appear - (TICRATE / 7)
				time_percent = (hud_ticker - time_o) * FRACUNIT / time_t
				
				emergency.x = background.x + SolEasing.Linear(time_percent, 68 * FRACUNIT, 100 * FRACUNIT)
				dday_type.x = background.x + SolEasing.Linear(time_percent, 144 * FRACUNIT, 112 * FRACUNIT)
			end
			if racecountdown then
				v.drawScaled(emergency.x, emergency.y, FRACUNIT, v.cachePatch(prefix..code),V_SNAPTOTOP|V_20TRANS, cachedColor)
				v.drawScaled(dday_type.x, dday_type.y, FRACUNIT, v.cachePatch(prefix..DDay_Overlay[server.XITdoomsday].text), V_SNAPTOTOP|V_20TRANS, cachedColor)
			end
		else
			v.drawScaled(0,0,1024 * FRACUNIT, v.cachePatch(DDay_Overlay[server.XITdoomsday].fade), V_SNAPTOTOP|V_SNAPTOLEFT)
		end
		
	end

	
	
	-- flush table
	if #splitplayers > splitscreen then
		splitplayers = {}
	end
end)

if xItemLib then
	xItemLib.func.addItem{
	"XITEM_DOOMSDAY", //Namespace
	"Doomsday Button", //Friendly Name
	"K_ITDDAY", //HUD Graphic
	"K_ISDDAY", //HUD Small Graphic
	XIF_POWERITEM|XIF_UNIQUE|XIF_COOLDOWNONSTART, //Flags
	{ 0, 0, 0, 0, 0, 0, 1, 0, 0, 0}, //Race Odds
	{1, 3}, //Battle Odds
	getDoomsday, //Get Item Function
	useDoomsday, //Use Item Function
	false, //HUD Item Function
	DoomsdayOdds, //Itemodds overrides
	nil, //Result Item Function
	{0, {SPR_DDAY, A}}, //Dropped Item Frames
	false, //Show in the item roulette
	nil,
	nil}
end