--Easing Library From SRB2, Remade in Kart by Jana Sol
--Thanks for letting me use it Jana :D (Dino needs it for Doomsday Button)

rawset(_G, "SolEasing", {})

local function InterpFix(startval, endval, time)
	return FixedMul((FRACUNIT - time), startval) + FixedMul(time, endval)
end

local function fixang(x)
	return FixedMul(x, 180*FRACUNIT)
end

SolEasing.Linear = function(time, startval, endval)
	return InterpFix(startval, endval, time)
end

SolEasing.InSine = function(time, startval, endval)
	local c = fixang(time/2)
	local x = FRACUNIT - cos(FixedAngle(c))
	return InterpFix(startval, endval, x)
end

SolEasing.OutSine = function(time, startval, endval)
	local c = fixang(time/2)
	local x = sin(FixedAngle(c))
	return InterpFix(startval, endval, x)
end

SolEasing.InOutSine = function(time, startval, endval)
	local c = fixang(time)
	local x = -(cos(FixedAngle(c))-FRACUNIT)/2
	return InterpFix(startval, endval, x)
end

SolEasing.OutInSine = function(time, startval, endval)
	local c = fixang(time)
	local x = (cos(FixedAngle(c))+FRACUNIT)/2
	return InterpFix(startval, endval, x)
end