-- Pewpew, by RetroStation

local TICRATE = TICRATE
local FRACUNIT = FRACUNIT
local ANG1 = ANG1
local k_itemamount = k_itemamount
local k_spinouttimer = k_spinouttimer

--item flags
local XIF_POWERITEM = 1 --is power item (affects final odds)
local XIF_COOLDOWNONSTART = 2 --can't be obtained on start cooldown
local XIF_UNIQUE = 4 --only one can exist in anyone's slot
local XIF_LOCKONUSE = 8 --locks the item slot when the item is used, slot must be unlocked manually by setting player.xItemData.xItem_itemSlotLocked to false
local XIF_COOLDOWNINDIRECT = 16 --checks if indirectitemcooldown is 0
local XIF_COLPATCH2PLAYER = 32 --map hud patch colour to player prefcolor
local XIF_ICONFORAMT = 64 --item icon changes depending on the item amount (animation frames become amount frames)


freeslot(
	"sfx_hmg",
	"sfx_hmgsht",
	"sfx_mngget",
	"MT_HMGBULLET",
	"S_HMGBULLET1",
	"S_HMGBULLET2",
	"MT_MINIGUNBULLET",
	"S_MINIGUNBULLET",
	"SPR_XEGB",
	"SPR_XMIN"
)
states[S_HMGBULLET1] = {SPR_JBUL, A|FF_FULLBRIGHT|FF_TRANS30, 3, nil, 0, 0, S_HMGBULLET2}
states[S_HMGBULLET2] = {SPR_JBUL, B|FF_FULLBRIGHT|FF_TRANS60, 3, nil, 0, 0, S_HMGBULLET1}
states[S_MINIGUNBULLET] = {SPR_NULL, A, -1, nil, 0, 0, S_MINIGUNBULLET}
mobjinfo[MT_HMGBULLET] = {
	spawnstate = S_HMGBULLET1,
	spawnhealth = 105,
	seesound = sfx_trfire,
	deathstate = S_SPRK1,
	deathsound = sfx_turhit,
	speed = 64*FRACUNIT,
	radius = 36*FRACUNIT,
	height = 32*FRACUNIT,
	mass = 100,
	flags = MF_NOGRAVITY|MF_SHOOTABLE|MF_MISSILE
}

mobjinfo[MT_MINIGUNBULLET] = {
	spawnstate = S_MINIGUNBULLET,
	spawnhealth = 20,
	seesound = sfx_trfire,
	deathstate = S_SPRK1,
	deathsound = sfx_turhit,
	speed = 240*FRACUNIT,
	radius = 36*FRACUNIT,
	height = 32*FRACUNIT,
	mass = 100,
	flags = MF_NOGRAVITY|MF_SHOOTABLE|MF_MISSILE
}

local function PowerCore(p, i)
	return xItemLib.xItemNamespaces["XITEM_EGGBLASTER"], min(max((p.kartstuff[k_position])/2,1), 3)
end

local function getHMG(p)
	--print("Ammo: "..p.XITgunammo.."/Max Ammo: "..p.XITmaxammo)
	xItemLib.func.xItem_setPlayerItemCooldown(p, TICRATE/2)
end

local function BeltLoad(p, i)
	return xItemLib.xItemNamespaces["XITEM_MINIGUN"], 15
end

local function getMinigun(p)
	xItemLib.func.xItem_setPlayerItemCooldown(p, TICRATE/2)
	S_StartSound(p.mo, sfx_mngget, p)
end

local function useHMG(p,cmd)
	p.combofire = $ or 0
	p.combofire = min($, 101)

	while p.cmd.buttons & BT_ATTACK
	and not (p.xItemData.xItem_itemSlotLockedTimer) 
		local bullet = RS_ShootBullet(p, true, MT_HMGBULLET, 0)
		bullet.momz = P_RandomRange(0, min(p.combofire/20, 5))*FRACUNIT
		bullet.hmgbullet = true
		--bullet.scale = mapobjectscale/2
		K_PlayAttackTaunt(p.mo)
		p.combofire = $ + 23
		p.kartstuff[k_itemamount] = max($ - 1, 0)
		xItemLib.func.xItem_setPlayerItemCooldown(p, 3)
	end
end

local function useMinigun(p,cmd)
	p.combofire = $ or 0
	p.combofire = min($, 101)

	while p.cmd.buttons & BT_ATTACK
	and not (p.xItemData.xItem_itemSlotLockedTimer)
		local bullet = RS_ShootBullet(p, true, MT_MINIGUNBULLET, 0)
		bullet.momz = (P_RandomRange(0, min(p.combofire/10, 8)))*FRACUNIT
		bullet.minigunbullet = true
		--bullet.scale = mapobjectscale/2
		if bullet and bullet.valid
			S_StartSound(p.mo, sfx_s3k4d)
		end
		K_PlayAttackTaunt(p.mo)
		if G_BattleGametype()
			p.combofire = $ + 42
		else
			p.combofire = $ + 22
		end
		p.kartstuff[k_itemamount] = max($ - 1, 0)
		xItemLib.func.xItem_setPlayerItemCooldown(p, 2)
	end
end

addHook("MobjDamage", function (mo, inf, s)
	if not (mo and mo.valid and mo.player) then return end
	local p = mo.player

	if not (inf and inf.valid) then return end
	if not (inf.type == MT_HMGBULLET or inf.type == MT_MINIGUNBULLET) then return end
	
	local pushx = FixedMul(FRACUNIT/4, inf.momx)
	local pushy = FixedMul(FRACUNIT/4, inf.momy)
	
	if (inf.flags2 & MF2_RAILRING) then -- Minigun
		pushx = FixedMul(FRACUNIT/10, inf.momx)
		pushy = FixedMul(FRACUNIT/10, inf.momy)
	end

	-- apply knockback
	if not (p.powers[pw_flashing]) then
		mo.momx = $ + pushx
		mo.momy = $ + pushy
	end
	S_StartSound(mo, sfx_s3k7b)
	
	-- spinout the player manually so we can wipeout the player instead of spinout
	if (p.kartstuff[k_invincibilitytimer] > 0)
	or (p.kartstuff[k_growshrinktimer] > 0 or (HugeQuest and p.hugequest.huge > 0))
	or (p.powers[pw_flashing])
		-- insta shield them instead!
		K_DoInstashield(p)
	else
		if ((s and s.valid) and s.player)
			K_PlayHitEmSound(s)
		end
		K_SpinPlayer(p, inf, 1, inf.target)
		P_PlayRinglossSound(mo)
		
		if G_BattleGametype() then
			if K_IsPlayerWanted(mo.player) then
				K_SpawnBattlePoints(s.player, nil, 3)
				s.player.marescore = $ + 3
			else
				K_SpawnBattlePoints(s.player, nil, 1)
				s.player.marescore = $ + 1
			end
		end

		if (hitfeed) then
			local c = s.player.skincolor
			local s = {{s.player.name, s.hf_overridenamecolor or s.player.skincolor}, {skins[s.skin].facemmap, s.player.skincolor}, s.player}
			local v = {{p.name, mo.hf_overridenamecolor or p.skincolor}, {skins[mo.skin].facemmap, p.skincolor}, p}
			local icon = "K_HMXEGB"
			
			if inf.type == MT_MINIGUNBULLET
				icon = "K_HMXMIN"
			end
			if (s[3] == v[3]) then s = nil end	-- source == victim, remove source
			
			HF_SendHitMessage(s, v, icon, c)
		end
		return true
	end
end, MT_PLAYER)



local function HMGRecoil(p)
	if p.combofire then
		p.combofire = max($-3, 0)
		p.combofire = min($, 100)
	end
end
addHook("PlayerThink", HMGRecoil)

if xItemLib then
	xItemLib.func.addItem{
	"XITEM_EGGBLASTER", //Namespace
	"Egg Blaster", //Friendly Name
	"K_ITXEGB", //HUD Graphic
	"K_ISXEGB", //HUD Small Graphic
	XIF_COLPATCH2PLAYER, //Flags
	{0, 4, 4, 4, 2, 0, 0, 0, 0, 0}, //Race Odds
	{8, 0}, //Battle Odds
	getHMG, //Get Item Function
	false, //Use Item Function
	false, //HUD Item Function
	false, //Itemodds overrides
	PowerCore, //Result Item Function
	{0, {SPR_XEGB, A}}, //Dropped Item Frames
	true, //Show in the item roulette
	useHMG,
	nil}

	xItemLib.func.addItem{
	"XITEM_MINIGUN", //Namespace
	"Minigun", //Friendly Name
	"K_ITXMIN", //HUD Graphic
	"K_ISXMIN", //HUD Small Graphic
	XIF_POWERITEM|XIF_COOLDOWNONSTART|XIF_COLPATCH2PLAYER, //Flags
	{ 0, 0, 0, 0, 0, 1, 0, 0, 0, 0 }, //Race Odds
	{1, 1}, //Battle Odds
	getMinigun, //Get Item Function
	false, //Use Item Function
	false, //HUD Item Function
	false, //Itemodds overrides
	BeltLoad, //Result Item Function
	{0, {SPR_XMIN, A}}, //Dropped Item Frames
	true, //Show in the item roulette
	useMinigun,
	nil}
end