-- BOOM HEADSHOT, by RetroStation

local TICRATE = TICRATE
local FRACUNIT = FRACUNIT
local ANG1 = ANG1
local k_itemamount = k_itemamount
local k_spinouttimer = k_spinouttimer

--item flags
local XIF_POWERITEM = 1 --is power item (affects final odds)
local XIF_COOLDOWNONSTART = 2 --can't be obtained on start cooldown
local XIF_UNIQUE = 4 --only one can exist in anyone's slot
local XIF_LOCKONUSE = 8 --locks the item slot when the item is used, slot must be unlocked manually by setting player.xItemData.xItem_itemSlotLocked to false
local XIF_COOLDOWNINDIRECT = 16 --checks if indirectitemcooldown is 0
local XIF_COLPATCH2PLAYER = 32 --map hud patch colour to player prefcolor
local XIF_ICONFORAMT = 64 --item icon changes depending on the item amount (animation frames become amount frames)

freeslot(
	"sfx_snpsht",
	"sfx_snpget",
	"sfx_snphds",
	"SPR_XSNP",
	"MT_SNIPERBULLET",
	"S_SNIPERBULLET"
)

states[S_SNIPERBULLET] = {SPR_NULL, A, -1, nil, 0, 0, S_SNIPERBULLET}
mobjinfo[MT_SNIPERBULLET] = {
	spawnstate = S_SNIPERBULLET,
	seesound = sfx_rail1,
	deathstate = S_SPRK1,
	deathsound = sfx_rail2,
	speed = 224*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 24*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY
}

local function getSniper(p)
	S_StartSound(p.mo, sfx_snpget, p)
	xItemLib.func.xItem_setPlayerItemCooldown(p, TICRATE/2)
end

local function useSniper(p,cmd)
	local sniper = RS_ShootBullet(p, true, MT_SNIPERBULLET, 0)

	K_PlayAttackTaunt(p.mo)
	S_StartSound(p.mo, sfx_snpsht)
	p.kartstuff[k_itemamount] = max($ - 1, 0)
	xItemLib.func.xItem_setPlayerItemCooldown(p, TICRATE)
end

local function RC_CannonShot(mo, inf, source, damage)
	if not (mo and mo.valid) then return end
	if not (inf and inf.valid) then return end
	
	if inf.type == MT_SNIPERBULLET then
		return true
	end
	return
end
addHook("ShouldDamage", RC_CannonShot)

addHook("MobjDamage", function(mo, inf, s)
	if not (mo and mo.valid and mo.player) then return end
	if not (inf and inf.valid) then return end
	local p = mo.player

	if inf.type == MT_SNIPERBULLET then
		if (battleplus and G_BattleGametype() and battleplus.gamemodes[2]) then
			local rings = battleplus.ringrunners.CalculateRingsOnPlayer(mo.player, 15)
			battleplus.ringrunners.GiveRings(mo.player, -rings)
			if (mo and mo.valid)	-- justified paranoia
				S_StartSound(mo, sfx_8blose)
			end
			battleplus.ringrunners.RingBurst(mo, rings, {-6, 6}, {-6, 6}, {14, 18})
		end
		S_StartSound(nil, sfx_snphds) -- Because everyone needs to know
		P_KillMobj(mo, inf, s)
		if ((s and s.valid) and s.player)
			K_PlayHitEmSound(s)
		end
			
		if G_BattleGametype() then
			if K_IsPlayerWanted(mo.player) then
				K_SpawnBattlePoints(s.player, nil, 3)
				s.player.marescore = $ + 3
			else
				K_SpawnBattlePoints(s.player, nil, 1)
				s.player.marescore = $ + 1
			end
		end
		if (hitfeed) then
			local c = s.player.skincolor
			local s = {{s.player.name, s.hf_overridenamecolor or s.player.skincolor}, {skins[s.skin].facemmap, s.player.skincolor}, s.player}
			local v = {{p.name, mo.hf_overridenamecolor or p.skincolor}, {skins[mo.skin].facemmap, p.skincolor}, p}
			local icon = "K_HMXSNP"
			if (s[3] == v[3]) then s = nil end	-- source == victim, remove source
			
			HF_SendHitMessage(s, v, icon, c)
		end
		return true
	end
end, MT_PLAYER)

local function CannonBounce(mo)
	P_InstaThrust(mo, R_PointToAngle2(0, 0, mo.momx, mo.momy), mo.info.speed)
	
	if (mo.edsniperfuse == nil) then mo.edsniperfuse = 3*TICRATE end
	mo.edsniperfuse = $-1
	
	if not mo.edsniperfuse then
		P_KillMobj(mo)
	end
end
addHook("MobjThinker", CannonBounce, MT_SNIPERBULLET)
if xItemLib then
	xItemLib.func.addItem{
	"XITEM_RINGCANNON", //Namespace
	"Ring Cannon", //Friendly Name
	"K_ITXSNP", //HUD Graphic
	"K_ISXSNP", //HUD Small Graphic
	XIF_COOLDOWNONSTART|XIF_POWERITEM|XIF_COLPATCH2PLAYER, //Flags
	{ 0, 0, 0, 0, 1, 1, 0, 0, 0, 0 }, //Race Odds
	{1, 1}, //Battle Odds
	getSniper, //Get Item Function
	useSniper, //Use Item Function
	false, //HUD Item Function
	false, //Itemodds overrides
	nil, //Result Item Function
	{0, {SPR_XSNP, A}}, //Dropped Item Frames
	false, //Show in the item roulette
	nil,
	nil}
end