-- Another fucking reimplementation, joy.
local function K_FindLastTrailMobj(player)
	local trail

	if not (player or (trail == player.mo) or player.mo.hnext or player.mo.hnext.health) then
		return 
	end

	while (trail.hnext and not P_MobjWasRemoved(trail.hnext) and trail.hnext.health)
		trail = trail.hnext
	end

	return trail
end

local function SpawnBullet(source, type, an, flags2, speed)
	local th
	local x, y, z
	local finalspeed = speed
	local throwmo

	if (source.player and source.player.speed > K_GetKartSpeed(source.player, false)) then
		local input = source.angle - an
		local invert = (input > ANGLE_180)
		if (invert)
			input = InvAngle(input)
		end
		
		finalspeed = max(speed, FixedMul(speed, FixedMul(FixedDiv(source.player.speed, K_GetKartSpeed(source.player, false)),(((180<<FRACBITS) - AngleFixed(input)) / 180))))
	end

	x = source.x + source.momx + FixedMul(finalspeed, cos(an))
	y = source.y + source.momy + FixedMul(finalspeed, sin(an))
	z = source.z

	if (P_MobjFlip(source) < 0)
		z = source.z+source.height - mobjinfo[type].height
	end

	th = P_SpawnMobj(x, y, z, type)

	th.flags2 = $|flags2

	th.threshold = 10

	if th.type == MT_HMGBULLET 
	or th.type == MT_MINIGUNBULLET
	or th.type == MT_SNIPERBULLET
	or th.type == MT_LAUNCHERROCKET then
		if source and source.player then
			th.color = source.player.skincolor
			th.colorized = true
		end
	elseif th.type == MT_SHOTGUNPELLET
		if source and source.player then
			th.color = ColorOpposite(source.player.skincolor)
			th.colorized = true
		end
	end

	if (th.info.seesound) then
		S_StartSound(source, th.info.seesound)
	end
	th.target = source

	if (P_IsObjectOnGround(source)) then
		// floorz and ceilingz aren't properly set to account for FOFs and Polyobjects on spawn
		// This should set it for FOFs
		P_SetOrigin(th, th.x, th.y, th.z)
		// spawn on the ground if the player is on the ground
		if (P_MobjFlip(source) < 0) then
			th.z = th.ceilingz - th.height
			th.eflags = $|MFE_VERTICALFLIP
		else
			th.z = th.floorz
		end
	end

	th.angle = an
	th.momx = FixedMul(finalspeed, cos(an))
	th.momy = FixedMul(finalspeed, sin(an))

	x = x + P_ReturnThrustX(source, an, source.radius + th.radius)
	y = y + P_ReturnThrustY(source, an, source.radius + th.radius)
	throwmo = P_SpawnMobj(x, y, z, MT_FIREDITEM)
	throwmo.movecount = 1
	throwmo.movedir = source.angle - an
	throwmo.target = source

	return th
end

rawset(_G,"RS_ShootBullet",function(player, missile, mapthing, defaultDir)
	if not (player and player.valid) then return end
	
	local mo
	local dir
	local PROJSPEED
	local newangle
	local newx, newy, newz
	local throwmo

	if (mapthing ~= MT_BALLHOG) then // Trying to keep compatibility...
		PROJSPEED = mobjinfo[mapthing].speed
		if (gamespeed == 0) then
			PROJSPEED = FixedMul(PROJSPEED, FRACUNIT-FRACUNIT/4)
		elseif (gamespeed == 2) then
			PROJSPEED = FixedMul(PROJSPEED, FRACUNIT+FRACUNIT/4)
		end
		PROJSPEED = FixedMul(PROJSPEED, mapobjectscale)
	else
		PROJSPEED = 82*mapobjectscale // Avg Speed is 41
		if gamespeed == 0 then
			PROJSPEED = 68*mapobjectscale // Avg Speed is 34
		elseif gamespeed == 2 then
			PROJSPEED = 96*mapobjectscale // Avg Speed is 48
		end
	end

	
	if (player.kartstuff[k_throwdir] ~= 0)
		dir = player.kartstuff[k_throwdir]
	else
		dir = defaultDir
	end
	
	if (missile) then // Shootables
		if player.kartstuff[k_itemtype] == xItemLib.xItemNamespaces["XITEM_MINIGUN"] then --Minigun check
			mo = SpawnBullet(player.mo, mapthing, player.mo.angle + P_RandomRange((min((2*player.combofire)/3, 20))*-1 , min((2*player.combofire)/3, 20))*ANG1, 0, PROJSPEED)
		elseif player.kartstuff[k_itemtype] == xItemLib.xItemNamespaces["XITEM_SNAPBLASTER"] then --Minigun check
			mo = SpawnBullet(player.mo, mapthing, player.mo.angle, 0, PROJSPEED)
		else
			if (dir == -1)
				local initangle = (player.mo.angle + ANGLE_180)
				if mapthing == MT_SHOTGUNPELLET then
					for i = 1, 12 do
						mo = SpawnBullet(player.mo, mapthing, initangle + (P_RandomRange(-3, 3)*(5*ANG1)), 0, PROJSPEED/8)
						mo.momz = P_RandomRange(0, 24)*FRACUNIT
					end
				elseif mapthing == MT_HMGBULLET then
					mo = SpawnBullet(player.mo, mapthing, initangle + P_RandomRange((min(player.combofire/10, 10))*-1 , min(player.combofire/10, 10))*ANG1, 0, PROJSPEED/8)
				elseif mapthing == MT_LAUNCHERROCKET then
					mo = SpawnBullet(player.mo, mapthing, initangle, 0, PROJSPEED/8)
				elseif mapthing == MT_SNIPERBULLET then
					mo = SpawnBullet(player.mo, mapthing, initangle, MF_BOUNCE, PROJSPEED)
				end
			else
				if mapthing == MT_SHOTGUNPELLET then
					local initangle = (player.mo.angle)
					for i = 1, 12 do
						mo = SpawnBullet(player.mo, mapthing, initangle + (P_RandomRange(-3, 3)*(5*ANG1)), MF2_SCATTER, PROJSPEED)
						mo.momx = $ + player.mo.momx
						mo.momy = $ + player.mo.momy
						mo.momz = P_RandomRange(0, 24)*FRACUNIT
					end
				elseif mapthing == MT_HMGBULLET then
					mo = SpawnBullet(player.mo, mapthing, player.mo.angle + P_RandomRange((min(player.combofire/10, 10))*-1 , min(player.combofire/10, 10))*ANG1, 0, PROJSPEED)
					mo.momx = $ + player.mo.momx
					mo.momy = $ + player.mo.momy
				elseif mapthing == MT_LAUNCHERROCKET then
					mo = SpawnBullet(player.mo, mapthing, player.mo.angle, 0, PROJSPEED)
					mo.momx = $ + player.mo.momx
					mo.momy = $ + player.mo.momy
				elseif mapthing == MT_SNIPERBULLET then
					mo = SpawnBullet(player.mo, mapthing, player.mo.angle, 0, PROJSPEED)
				end
			end
		end
		
		if mo and mo.valid 
		and not (mo.type == MT_LAUNCHERROCKET) then
			if mo.flags2 & MF2_RAILRING then
				for i = 0, 255
					local spark
					-- spark trail
					if (i%2) then
						spark = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPARK)
						spark.color = player.skincolor
						spark.colorized = true
					end
					-- move the ring continuously in the loop to make it act like a rail
					if not (P_TryMove(mo, mo.x + mo.momx, mo.y + mo.momy, true))
						--print("Dead Sniper Bullet")
						P_KillMobj(mo)
						break
					end
				end
			
				-- if it's still valid here, remove it
				if (mo and mo.valid) then
					--print("Dead Sniper Bullet")
					P_KillMobj(mo)
				end
			end
		end
	else
		player.kartstuff[k_bananadrag] = 0 // RESET timer, for multiple bananas

		if (dir > 0) then
			// Shoot forward
			mo = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z + player.mo.height/2, mapthing)
			//K_FlipFromObject(mo, player->mo);
			// These are really weird so let's make it a very specific case to make SURE it works...
			if (player.mo.eflags & MFE_VERTICALFLIP) then
				mo.z = $ - player.mo.height
				mo.flags2 = $|MF2_OBJECTFLIP
				mo.eflags = $|MFE_VERTICALFLIP
			end

			mo.threshold = 10
			mo.target = player.mo

			S_StartSound(player.mo, mo.info.seesound)

			if (mo) then
				local fa = player.mo.angle
				local HEIGHT = (20 + (dir*10))*mapobjectscale + (player.mo.momz*P_MobjFlip(player.mo))

				mo.momz = HEIGHT*P_MobjFlip(mo)
				mo.momx = player.mo.momx + FixedMul(cos(fa), PROJSPEED*dir)
				mo.momy = player.mo.momy + FixedMul(sin(fa), PROJSPEED*dir)

				mo.extravalue2 = dir

				if (mo.eflags & MFE_UNDERWATER) then
					mo.momz = (117 * mo.momz) / 200
				end
			end

			// this is the small graphic effect that plops in you when you throw an item:
			throwmo = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z + player.mo.height/2, MT_FIREDITEM)
			throwmo.target = player.mo
			// Ditto:
			if (player.mo.eflags & MFE_VERTICALFLIP) then
				throwmo.z = $ - player.mo.height
				throwmo.flags2 = $|MF2_OBJECTFLIP
				throwmo.eflags = $|MFE_VERTICALFLIP
			end

			throwmo.movecount = 0 // above player
		else
			local lasttrail = K_FindLastTrailMobj(player)

			if (lasttrail) then
				newx = lasttrail.x
				newy = lasttrail.y
				newz = lasttrail.z
			else
				// Drop it directly behind you.
				local dropradius = FixedHypot(player.mo.radius, player.mo.radius) + FixedHypot(mobjinfo[mapthing].radius, mobjinfo[mapthing].radius)

				newangle = player.mo.angle

				newx = player.mo.x + P_ReturnThrustX(player.mo, newangle + ANGLE_180, dropradius)
				newy = player.mo.y + P_ReturnThrustY(player.mo, newangle + ANGLE_180, dropradius)
				newz = player.mo.z
			end

			mo = P_SpawnMobj(newx, newy, newz, mapthing) // this will never return null because collision isn't processed here
			K_FlipFromObject(mo, player.mo)

			mo.threshold = 10
			mo.target = player.mo

			if (P_IsObjectOnGround(player.mo))
				// floorz and ceilingz aren't properly set to account for FOFs and Polyobjects on spawn
				// This should set it for FOFs
				P_SetOrigin(mo, mo.x, mo.y, mo.z); // however, THIS can fuck up your day. just absolutely ruin you.
				if not (mo and mo.valid) then
					return
				end

				if (P_MobjFlip(mo) > 0)
					if (mo.floorz > mo.target.z - mo.height)
						mo.z = mo.floorz
					end
				else
					if (mo.ceilingz < mo.target.z + mo.target.height + mo.height)
						mo.z = mo.ceilingz - mo.height
					end
				end
			end
			
			if (player.mo.eflags & MFE_VERTICALFLIP)
				mo.eflags = $|MFE_VERTICALFLIP
			end
			
			if (mapthing == MT_SSMINE)
				mo.extravalue1 = 49; // Pads the start-up length from 21 frames to a full 2 seconds
			end
		end
	end

	return mo
end)

local function bulletCollide(mo, mo2)
	if not (mo and mo.valid) then return end
	if not (mo2 and mo2.valid) then return end
	if not (mo.target and mo.target.valid) then return end
	if not (mo2.target and mo2.target.valid) then return end
	
	if mo2.type == mo.type
	and mo.target == mo2.target then
		return false
	end
	return
end

local function sp_SparkleMaker(mo)
	local r = (mo.radius/FRACUNIT)*4
	local z = (P_RandomKey((mo.height/FRACUNIT)*2)*FRACUNIT)
	local shiny = P_SpawnMobj(mo.x + (P_RandomRange(r, -r)*FRACUNIT), mo.y + (P_RandomRange(r, -r)*FRACUNIT), mo.z + z, MT_SPARKLETRAIL)
	shiny.target = mo
	shiny.color = mo.color
end

local omelettes = {MT_HMGBULLET, MT_MINIGUNBULLET, MT_SHOTGUNPELLET, MT_SNIPERBULLET}
for _, i in ipairs(omelettes) do
	addHook("MobjSpawn", function(mo)
		if (mo.type == MT_HMGBULLET) then
			mo.scale = mapobjectscale
		else
			mo.scale = (2*mapobjectscale)
		end
	end, i)
	
	addHook("MobjCollide", bulletCollide, i)
	addHook("MobjThinker", function(mo)
		if not (mo and mo.valid) then return end
		
		if mo.threshold then
			mo.threshold = max($ - 1, 0)
		end
		
		if (mo.target and mo.target.valid and mo.target.player) then
			if (mo.type == MT_HMGBULLET
			or mo.type == MT_SNIPERBULLET 
			or mo.type == MT_SHOTGUNPELLET
			or mo.type == MT_MINIGUNBULLET)then
				--if leveltime%(TICRATE/7) == 0 then
					local vfx = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPARK)
					vfx.scale = (mo.scale*3)/2
					vfx.color = mo.target.player.skincolor
					vfx.colorized = true
				--end
			end
		end
		
		if (mo.type == MT_HMGBULLET
			or mo.type == MT_SHOTGUNPELLET
			or mo.type == MT_MINIGUNBULLET)then
				if mo.health then
					mo.health = max($-1, 0)
			
					if not mo.health then
						P_KillMobj(mo)
					end
				end
			end
	end, i)
end

local guns = {
	xItemLib.xItemNamespaces["XITEM_SHOTGUN"],
	xItemLib.xItemNamespaces["XITEM_MINIGUN"],
	xItemLib.xItemNamespaces["XITEM_EGGBLASTER"],
	xItemLib.xItemNamespaces["XITEM_RINGCANNON"],
	xItemLib.xItemNamespaces["XITEM_ROCKETLAUNCHER"],
	xItemLib.xItemNamespaces["XITEM_CHAMELEONBLASTER"]
}

local function gunCooldown(p)
	
	if (p.lastspin and not p.kartstuff[k_spinouttimer])
	or p.kartstuff[k_respawn]
		for _,i in ipairs(guns) do
			if p.kartstuff[k_itemtype] == i then
				p.gunrecovery = true
				break
			end
		end
	end

	if p.powers[pw_flashing]
	and (p.gunrecovery)
		xItemLib.func.xItem_setPlayerItemCooldown(p, (2*TICRATE)/3)
		p.gunrecovery = nil
	end
	
	p.lastspin = p.kartstuff[k_spinouttimer]
end

addHook("PlayerThink", gunCooldown)

local combibullets = {MT_HMGBULLET, MT_SHOTGUNPELLET, MT_LAUNCHERROCKET, MT_SNIPERBULLET, MT_MINIGUNBULLET}
local function Combi_Interop(mo, mo2)
	if not (hcombi and hcombi.combi_on) then return end
	if (hcombi and hcombi.cv_ffire.value) then return end -- friendly fire on
	-- make sure its actually a player
	if (mo and mo.valid and mo.player and mo.player.valid)
		if (mo2 and mo2.valid)
			for _, i in ipairs(combibullets) do
				if mo2.type == i	
				and (mo2.target and mo2.target.valid)
				and (mo2.target.player and mo2.target.player.valid)
				and (mo2.target.player == mo.player.combi_p)
					return false
				end
			end
		end
	end
	return
end

addHook("MobjCollide", Combi_Interop, MT_PLAYER)
addHook("MobjMoveCollide", Combi_Interop, MT_PLAYER)